VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWindow"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Uses Windows API to obtain window list
'
'Author
'  Name .....: Josip Medved
'  E-mail ...: jmedved@vip.hr
'  URL ......: http://web.vip.hr/jmedved.vip/qeyes/

'Information
'  Additional : -
'  Requires ..: -
'  Has help ..: No
'  Has readme : No
'  Has sample : Yes
'  Created ...: 2002/09/11 (yyyy/mm/dd)
'  Last update: 2002/09/11 (yyyy/mm/dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.


Option Explicit

Private xHandles() As Long
Private xHandlesCount As Long
Private xHandlesMaxCount As Long

Private Const GW_CHILD = 5
Private Const GW_HWNDNEXT = 2
Private Const GWL_STYLE = (-16)
Private Const WS_CAPTION = &HC00000                  '  WS_BORDER Or WS_DLGFRAME
Private Const GWL_EXSTYLE = (-20)
Private Const WS_EX_APPWINDOW = &H40000
Private Const GWL_HINSTANCE = (-6)


Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long
Private Declare Function SetWindowText Lib "user32" Alias "SetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String) As Long
Private Declare Function IsWindowVisible Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long


Public Sub Init(Optional ByVal FilterNonApp As Boolean = False, Optional ByVal FilterInvisible As Boolean = False, Optional ByVal FilterChilds As Boolean = False)
  Erase xHandles()
  xHandlesMaxCount = 0
  xHandlesCount = 0

  Dim tmpHwnd As Long, tmpIgnore As Boolean, tmpRet As Long, tmpRet2 As Long
  tmpHwnd = GetDesktopWindow()
  tmpHwnd = GetWindow(tmpHwnd, GW_CHILD)
  Do Until tmpHwnd = 0
    tmpIgnore = False
    If xHandlesCount >= xHandlesMaxCount Then
      xHandlesMaxCount = xHandlesMaxCount + 16
      ReDim Preserve xHandles(0 To xHandlesMaxCount - 1)
    End If
    
    If (tmpIgnore = False) And (FilterNonApp = True) Then
      tmpRet = GetWindowLong(tmpHwnd, GWL_STYLE)
      tmpRet2 = GetWindowLong(tmpHwnd, GWL_EXSTYLE)
      If ((tmpRet And WS_CAPTION) <> WS_CAPTION) And ((tmpRet2 And WS_EX_APPWINDOW) <> WS_EX_APPWINDOW) Then tmpIgnore = True
    End If
    
    If (tmpIgnore = False) And (FilterInvisible = True) Then
      tmpRet = IsWindowVisible(tmpHwnd)
      If tmpRet = 0 Then tmpIgnore = True
    End If

    If (tmpIgnore = False) And (FilterChilds = True) Then
      tmpRet = GetParent(tmpHwnd)
      If tmpRet <> 0 Then tmpIgnore = True
    End If

    If (tmpIgnore = False) Then
      xHandles(xHandlesCount) = tmpHwnd
      xHandlesCount = xHandlesCount + 1
    End If
    tmpHwnd = GetWindow(tmpHwnd, GW_HWNDNEXT)
  Loop

  If xHandlesCount > 0 Then
    ReDim Preserve xHandles(0 To xHandlesCount - 1)
  Else
    Erase xHandles()
  End If
End Sub

Public Property Get HandleCount() As Long
  HandleCount = xHandlesCount
End Property

Public Property Get Handle(ByVal Index As Long) As Long
  If (Index < 0) Or (Index >= xHandlesCount) Then Exit Property

  Handle = xHandles(Index)
End Property

Public Property Get Caption(ByVal Index As Long) As String
  If (Index < 0) Or (Index >= xHandlesCount) Then Exit Property

  Caption = CaptionByHandle(xHandles(Index))
End Property

Public Property Let Caption(ByVal Index As Long, Caption As String)
  If (Index < 0) Or (Index >= xHandlesCount) Then Exit Property

  CaptionByHandle(xHandles(Index)) = Caption
End Property

Public Property Get ModuleFileName(ByVal Index As Long) As String
  If (Index < 0) Or (Index >= xHandlesCount) Then Exit Property

  ModuleFileName = ModuleFileNameByHandle(xHandles(Index))
End Property

Public Property Get CaptionByHandle(ByVal Handle As Long) As String
  Dim tmpRet As Long, tmpBuffer As String
  tmpRet = GetWindowTextLength(Handle)
  tmpBuffer = String$(tmpRet + 1, 0)
  tmpRet = GetWindowText(Handle, tmpBuffer, Len(tmpBuffer))
  CaptionByHandle = Left$(tmpBuffer, tmpRet)
End Property

Public Property Let CaptionByHandle(ByVal Handle As Long, Caption As String)
  Dim tmpRet As Long
  tmpRet = SetWindowText(Handle, Caption)
End Property

Public Property Get ModuleFileNameByHandle(ByVal Handle As Long) As String
  Dim hInstance As Long
  hInstance = GetWindowLong(Handle, GWL_HINSTANCE)

  Dim tmpRet As Long, tmpBuffer As String
  tmpBuffer = String$(1024, 0)
  tmpRet = GetModuleFileName(hInstance, tmpBuffer, Len(tmpBuffer))
  ModuleFileNameByHandle = Left$(tmpBuffer, tmpRet)
End Property


Private Sub Class_Initialize()
  Init
End Sub
