VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsXY"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Used to create X-Y space
'
'Author
'  Name .....: Josip Medved
'  E-mail ...: jmedved@vip.hr
'  URL ......: http://web.vip.hr/jmedved.vip/qeyes/

'Information
'  Additional : -
'  Requires ..: -
'  Has help ..: No
'  Has readme : No
'  Has sample : Yes
'  Created ...: 2002/09/18 (yyyy/mm/dd)
'  Last update: 2002/09/18 (yyyy/mm/dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.


Option Explicit

Private xPictureObject As Variant
Private xBackColor As Long
Private xXMax  As Single
Private xXMin  As Single
Private xYMax  As Single
Private xYMin  As Single
Private xUseCurrentRect As Boolean
Private xLeft As Single
Private xTop As Single
Private xWidth As Single
Private xHeight As Single

Private xHadLast As Boolean
Private xLastX As Single
Private xLastY As Single

Public Sub Init(PictureObject As Variant, Optional ByVal BackColor As Long = vbWindowBackground, Optional XMin As Single = -1, Optional XMax As Single = 1, Optional YMin As Single = -1, Optional YMax As Single = 1, Optional ByVal UseCurrentRect As Boolean = True, Optional ByVal RectLeft As Single = 0, Optional ByVal RectTop As Single = 0, Optional ByVal RectWidth As Single = 0, Optional ByVal RectHeight As Single = 0)
  Set xPictureObject = PictureObject
  xBackColor = BackColor

  xXMin = XMin
  xXMax = XMax
  xYMin = YMin
  xYMax = YMax

  xUseCurrentRect = UseCurrentRect
  If UseCurrentRect = True Then
    xLeft = xPictureObject.ScaleLeft
    xTop = xPictureObject.ScaleTop
    xWidth = xPictureObject.ScaleWidth
    xHeight = xPictureObject.ScaleHeight
  Else
    xLeft = RectLeft
    xTop = RectTop
    xWidth = RectWidth
    xHeight = RectHeight
  End If

  xPictureObject.Line (xLeft, xTop)-(xLeft + xWidth, xTop + xHeight), xBackColor, BF

  xHadLast = False
End Sub

Public Sub Point(ByVal X As Single, ByVal Y As Single, Optional ByVal ForeColor As Long = vbButtonText, Optional ByVal ConnectWithLast As Boolean = False)
  Dim tmpX As Single, tmpY As Single

  If ConnectWithLast = True Then
    If xHadLast = True Then
      DrawLine xLastX, xLastY, X, Y, ForeColor
      xLastX = X
      xLastY = Y
    Else
      xLastX = X
      xLastY = Y
      xHadLast = True
    End If
  Else
    xHadLast = False
  End If

  If (X < xXMin) Or (X > xXMax) Then Exit Sub
  If (Y < xYMin) Or (Y > xYMax) Then Exit Sub

  pConvertXY X, Y, tmpX, tmpY
    
  xPictureObject.PSet (tmpX, tmpY), ForeColor
End Sub

Public Sub DrawLine(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, Optional ByVal ForeColor As Long = vbButtonText)
  If (X1 < xXMin) And (X2 < xXMin) Then Exit Sub
  If (X1 > xXMax) And (X2 > xXMax) Then Exit Sub
  If (Y1 < xYMin) And (Y2 < xYMin) Then Exit Sub
  If (Y1 > xYMax) And (Y2 > xYMax) Then Exit Sub

  If (X1 < xXMin) Or (X1 > xXMax) Or (X2 < xXMin) Or (X2 > xXMax) Or (Y1 < xYMin) Or (Y1 > xYMax) Or (Y2 < xYMin) Or (Y2 > xYMax) Then
    Dim A As Single, B As Single, C As Single, tmpXN As Single, tmpYN As Single
    Dim AR As Single, BR As Single, CR As Single
    pCalcABC X1, Y1, X2, Y2, A, B, C

    'Left
    If (X1 < xXMin) Or (X2 < xXMin) Then
      pCalcABC xXMin, xYMax, xXMin, xYMin, AR, BR, CR
      If pCalcXY(A, B, C, AR, BR, CR, tmpXN, tmpYN) = True Then
        If tmpXN = xXMin Then
          If X1 < X2 Then
            X1 = xXMin: Y1 = tmpYN
          Else
            X2 = xXMin: Y2 = tmpYN
          End If
        End If
      End If
    End If

    'Right
    If (X1 > xXMax) Or (X2 > xXMax) Then
      pCalcABC xXMax, xYMax, xXMax, xYMin, AR, BR, CR
      If pCalcXY(A, B, C, AR, BR, CR, tmpXN, tmpYN) = True Then
        If tmpXN = xXMax Then
          If X1 > X2 Then
            X1 = xXMax: Y1 = tmpYN
          Else
            X2 = xXMax: Y2 = tmpYN
          End If
        End If
      End If
    End If

    'Top
    If (Y1 > xYMax) Or (Y2 > xYMax) Then
      pCalcABC xXMin, xYMax, xXMax, xYMax, AR, BR, CR
      If pCalcXY(A, B, C, AR, BR, CR, tmpXN, tmpYN) = True Then
        If tmpYN = xYMax Then
          If Y1 > Y2 Then
            X1 = tmpXN: Y1 = xYMax
          Else
            X2 = tmpXN: Y2 = xYMax
          End If
        End If
      End If
    End If

    'Bottom
    If (Y1 < xYMin) Or (Y2 < xYMin) Then
      pCalcABC xXMin, xYMin, xXMax, xYMin, AR, BR, CR
      If pCalcXY(A, B, C, AR, BR, CR, tmpXN, tmpYN) = True Then
        If tmpYN = xYMin Then
          If Y1 < Y2 Then
            X1 = tmpXN: Y1 = xYMin
          Else
            X2 = tmpXN: Y2 = xYMin
          End If
        End If
      End If
    End If

  End If


  Dim tmpX1 As Single, tmpY1 As Single
  Dim tmpX2 As Single, tmpY2 As Single

  pConvertXY X1, Y1, tmpX1, tmpY1
  pConvertXY X2, Y2, tmpX2, tmpY2

  xPictureObject.Line (tmpX1, tmpY1)-(tmpX2, tmpY2), ForeColor
End Sub

Public Sub DrawAxis(ByVal XStep As Single, ByVal YStep As Single, ByVal Size As Single, Optional ByVal ForeColor As Long = vbButtonText)
  DrawLine xXMin, 0, xXMax, 0, ForeColor
  DrawLine 0, xYMin, 0, xYMax, ForeColor

  Dim i As Single, tmpX As Single, tmpY As Single
  If XStep > 0 Then
    For i = -XStep To xXMin Step -XStep
      pConvertXY i, 0, tmpX, tmpY
      xPictureObject.Line (tmpX, tmpY - Size)-(tmpX, tmpY + Size), ForeColor
    Next i
    For i = XStep To xXMax Step XStep
      pConvertXY i, 0, tmpX, tmpY
      xPictureObject.Line (tmpX, tmpY - Size)-(tmpX, tmpY + Size), ForeColor
    Next i
  End If
  If YStep > 0 Then
    For i = -YStep To xYMin Step -YStep
      pConvertXY 0, i, tmpX, tmpY
      xPictureObject.Line (tmpX - Size, tmpY)-(tmpX + Size, tmpY), ForeColor
    Next i
    For i = YStep To xYMax Step YStep
      pConvertXY 0, i, tmpX, tmpY
      xPictureObject.Line (tmpX - Size, tmpY)-(tmpX + Size, tmpY), ForeColor
    Next i
  End If
End Sub


Private Sub pConvertXY(ByVal X As Single, ByVal Y As Single, ByRef RealX As Single, ByRef RealY As Single)
  RealX = xLeft + (xWidth / (xXMax - xXMin)) * (X - xXMin)
  RealY = xTop + (xHeight / (xYMax - xYMin)) * (-Y + xYMax)
End Sub

Private Sub pCalcABC(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, ByRef A As Single, ByRef B As Single, ByRef C As Single)
  A = Y2 - Y1
  B = X1 - X2
  C = Y1 * (X2 - X1) - X1 * (Y2 - Y1)
End Sub

Private Function pCalcXY(ByVal A1 As Single, ByVal B1 As Single, ByVal C1 As Single, ByVal A2 As Single, ByVal B2 As Single, ByVal C2 As Single, ByRef X As Single, ByRef Y As Single) As Boolean
  On Error Resume Next
  Dim AQ As Single, BQ As Single, CQ As Single
  AQ = A1 / A2
  BQ = B1 / B2
  CQ = C1 / C2
  If (AQ = BQ) And (BQ = CQ) Then
  Else
    X = (B1 * C2 - B2 * C1) / (A1 * B2 - A2 * B1)
    Y = (C1 * A2 - C2 * A1) / (A1 * B2 - A2 * B1)
    pCalcXY = True
  End If
End Function
