Attribute VB_Name = "mdlBrowse"
'Author
'  Name .....: Josip Medved
'  E-mail ...: jmedved@vip.hr
'  URL ......: http://web.vip.hr/jmedved.vip/qeyes/

'Information
'  Additional : -
'  Requires ..: -
'  Has help ..: No
'  Has readme : No
'  Has sample : Yes
'  Created ...: 2002/04/07 (yyyy/mm/dd)
'  Last update: 2002/04/12 (yyyy/mm/dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.


Option Explicit

Public Enum eqBrowse
  qeBrowseDefault = 0
  qeBrowseDesktop = 1
  qeBrowseProgramsFolder = 2
  qeBrowseControlPanel = 3
  qeBrowsePrinters = 4
  qeBrowseDocumentsFolder = 5
  qeBrowseFavoritesFolder = 6
  qeBrowseStarupFolder = 7
  qeBrowseRecentFolder = 8
  qeBrowseSendToFolder = 9
  qeBrowseRecycleBin = 10
  qeBrowseStartMenuFolder = 11
  qeBrowseDesktopFolder = 12
  qeBrowseMyComputer = 17
  qeBrowseNetworkNeighborhood = 18
  qeBrowseNetHoodFolder = 19
  qeBrowseFontsFolder = 20
  qeBrowseShellNewFolder = 21
End Enum

Private Type SHITEMID
  cb As Long
  abID As Byte
End Type

Private Type ITEMIDLIST
  mkid As SHITEMID
End Type

Private Type BROWSEINFO
  hOwner As Long
  pidlRoot As Long
  pszDisplayName As String
  lpszTitle As String
  ulFlags As Long
  lpfn As Long
  lParam As Long
  iImage As Long
End Type

Private Const BIF_RETURNONLYFSDIRS = &H1
Private Const BIF_DONTGOBELOWDOMAIN = &H2
Private Const BIF_STATUSTEXT = &H4
Private Const BIF_RETURNFSANCESTORS = &H8
Private Const BIF_BROWSEFORCOMPUTER = &H1000
Private Const BIF_BROWSEFORPRINTER = &H2000
Private Const MAX_PATH = 260

Private Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long

Public Function BrowseGetPath(ByVal Path As eqBrowse, Optional ByVal OnlySubFolder As Boolean = True, Optional ByVal hwnd As Long = 0, Optional ByVal Title As String = "Browse") As String
  Dim bi As BROWSEINFO
  Dim idl As ITEMIDLIST

  Dim tmpP As Long
  If Path = 1 Then
    tmpP = 0
  Else
    tmpP = Path
  End If

  bi.hOwner = hwnd

  If Path <> 0 Then
    Dim tmpRet As Long
    tmpRet = SHGetSpecialFolderLocation(ByVal hwnd, tmpP, idl)
    bi.pidlRoot = idl.mkid.cb
  End If
 
  bi.lpszTitle = Title
  If OnlySubFolder = False Then
    bi.ulFlags = bi.ulFlags Or BIF_RETURNONLYFSDIRS
  Else
    bi.ulFlags = bi.ulFlags Or BIF_RETURNFSANCESTORS
  End If
  tmpRet = SHBrowseForFolder(bi)

  Dim tmpBuff As String, tmp As Long
  tmpBuff = String$(MAX_PATH, 0)
  tmpRet = SHGetPathFromIDList(ByVal tmpRet, ByVal tmpBuff)
  If tmpRet <> 0 Then
    BrowseGetPath = Left$(tmpBuff, InStr(tmpBuff, vbNullChar) - 1)
  Else
    BrowseGetPath = ""
  End If
End Function
