Attribute VB_Name = "mdlCRC16"
'Author
'  Name .....: Josip Medved
'  E-mail ...: jmedved@vip.hr
'  URL ......: http://web.vip.hr/jmedved.vip/qeyes/

'Information
'  Additional : -
'  Required ..: -
'  Has help ..: No
'  Has readme : No
'  Has sample : Yes
'  Created ...: 2002/04/12 (yyyy/mm/dd)
'  Last update: 2002/04/12 (yyyy/mm/dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.


Option Explicit


Private LookupTable(0 To 255) As Integer

Public Sub CRC16Init()
  LookupTable(0) = &H0: LookupTable(1) = &HC0C1: LookupTable(2) = &HC181: LookupTable(3) = &H140: LookupTable(4) = &HC301: LookupTable(5) = &H3C0: LookupTable(6) = &H280: LookupTable(7) = &HC241
  LookupTable(8) = &HC601: LookupTable(9) = &H6C0: LookupTable(10) = &H780: LookupTable(11) = &HC741: LookupTable(12) = &H500: LookupTable(13) = &HC5C1: LookupTable(14) = &HC481: LookupTable(15) = &H440
  LookupTable(16) = &HCC01: LookupTable(17) = &HCC0: LookupTable(18) = &HD80: LookupTable(19) = &HCD41: LookupTable(20) = &HF00: LookupTable(21) = &HCFC1: LookupTable(22) = &HCE81: LookupTable(23) = &HE40
  LookupTable(24) = &HA00: LookupTable(25) = &HCAC1: LookupTable(26) = &HCB81: LookupTable(27) = &HB40: LookupTable(28) = &HC901: LookupTable(29) = &H9C0: LookupTable(30) = &H880: LookupTable(31) = &HC841
  LookupTable(32) = &HD801: LookupTable(33) = &H18C0: LookupTable(34) = &H1980: LookupTable(35) = &HD941: LookupTable(36) = &H1B00: LookupTable(37) = &HDBC1: LookupTable(38) = &HDA81: LookupTable(39) = &H1A40
  LookupTable(40) = &H1E00: LookupTable(41) = &HDEC1: LookupTable(42) = &HDF81: LookupTable(43) = &H1F40: LookupTable(44) = &HDD01: LookupTable(45) = &H1DC0: LookupTable(46) = &H1C80: LookupTable(47) = &HDC41
  LookupTable(48) = &H1400: LookupTable(49) = &HD4C1: LookupTable(50) = &HD581: LookupTable(51) = &H1540: LookupTable(52) = &HD701: LookupTable(53) = &H17C0: LookupTable(54) = &H1680: LookupTable(55) = &HD641
  LookupTable(56) = &HD201: LookupTable(57) = &H12C0: LookupTable(58) = &H1380: LookupTable(59) = &HD341: LookupTable(60) = &H1100: LookupTable(61) = &HD1C1: LookupTable(62) = &HD081: LookupTable(63) = &H1040

  LookupTable(64) = &HF001: LookupTable(65) = &H30C0: LookupTable(66) = &H3180: LookupTable(67) = &HF141: LookupTable(68) = &H3300: LookupTable(69) = &HF3C1: LookupTable(70) = &HF281: LookupTable(71) = &H3240
  LookupTable(72) = &H3600: LookupTable(73) = &HF6C1: LookupTable(74) = &HF781: LookupTable(75) = &H3740: LookupTable(76) = &HF501: LookupTable(77) = &H35C0: LookupTable(78) = &H3480: LookupTable(79) = &HF441
  LookupTable(80) = &H3C00: LookupTable(81) = &HFCC1: LookupTable(82) = &HFD81: LookupTable(83) = &H3D40: LookupTable(84) = &HFF01: LookupTable(85) = &H3FC0: LookupTable(86) = &H3E80: LookupTable(87) = &HFE41
  LookupTable(88) = &HFA01: LookupTable(89) = &H3AC0: LookupTable(90) = &H3B80: LookupTable(91) = &HFB41: LookupTable(92) = &H3900: LookupTable(93) = &HF9C1: LookupTable(94) = &HF881: LookupTable(95) = &H3840
  LookupTable(96) = &H2800: LookupTable(97) = &HE8C1: LookupTable(98) = &HE981: LookupTable(99) = &H2940: LookupTable(100) = &HEB01: LookupTable(101) = &H2BC0: LookupTable(102) = &H2A80: LookupTable(103) = &HEA41
  LookupTable(104) = &HEE01: LookupTable(105) = &H2EC0: LookupTable(106) = &H2F80: LookupTable(107) = &HEF41: LookupTable(108) = &H2D00: LookupTable(109) = &HEDC1: LookupTable(110) = &HEC81: LookupTable(111) = &H2C40
  LookupTable(112) = &HE401: LookupTable(113) = &H24C0: LookupTable(114) = &H2580: LookupTable(115) = &HE541: LookupTable(116) = &H2700: LookupTable(117) = &HE7C1: LookupTable(118) = &HE681: LookupTable(119) = &H2640
  LookupTable(120) = &H2200: LookupTable(121) = &HE2C1: LookupTable(122) = &HE381: LookupTable(123) = &H2340: LookupTable(124) = &HE101: LookupTable(125) = &H21C0: LookupTable(126) = &H2080: LookupTable(127) = &HE041
        
  LookupTable(128) = &HA001: LookupTable(129) = &H60C0: LookupTable(130) = &H6180: LookupTable(131) = &HA141: LookupTable(132) = &H6300: LookupTable(133) = &HA3C1: LookupTable(134) = &HA281: LookupTable(135) = &H6240
  LookupTable(136) = &H6600: LookupTable(137) = &HA6C1: LookupTable(138) = &HA781: LookupTable(139) = &H6740: LookupTable(140) = &HA501: LookupTable(141) = &H65C0: LookupTable(142) = &H6480: LookupTable(143) = &HA441
  LookupTable(144) = &H6C00: LookupTable(145) = &HACC1: LookupTable(146) = &HAD81: LookupTable(147) = &H6D40: LookupTable(148) = &HAF01: LookupTable(149) = &H6FC0: LookupTable(150) = &H6E80: LookupTable(151) = &HAE41
  LookupTable(152) = &HAA01: LookupTable(153) = &H6AC0: LookupTable(154) = &H6B80: LookupTable(155) = &HAB41: LookupTable(156) = &H6900: LookupTable(157) = &HA9C1: LookupTable(158) = &HA881: LookupTable(159) = &H6840
  LookupTable(160) = &H7800: LookupTable(161) = &HB8C1: LookupTable(162) = &HB981: LookupTable(163) = &H7940: LookupTable(164) = &HBB01: LookupTable(165) = &H7BC0: LookupTable(166) = &H7A80: LookupTable(167) = &HBA41
  LookupTable(168) = &HBE01: LookupTable(169) = &H7EC0: LookupTable(170) = &H7F80: LookupTable(171) = &HBF41: LookupTable(172) = &H7D00: LookupTable(173) = &HBDC1: LookupTable(174) = &HBC81: LookupTable(175) = &H7C40
  LookupTable(176) = &HB401: LookupTable(177) = &H74C0: LookupTable(178) = &H7580: LookupTable(179) = &HB541: LookupTable(180) = &H7700: LookupTable(181) = &HB7C1: LookupTable(182) = &HB681: LookupTable(183) = &H7640
  LookupTable(184) = &H7200: LookupTable(185) = &HB2C1: LookupTable(186) = &HB381: LookupTable(187) = &H7340: LookupTable(188) = &HB101: LookupTable(189) = &H71C0: LookupTable(190) = &H7080: LookupTable(191) = &HB041
    
  LookupTable(192) = &H5000: LookupTable(193) = &H90C1: LookupTable(194) = &H9181: LookupTable(195) = &H5140: LookupTable(196) = &H9301: LookupTable(197) = &H53C0: LookupTable(198) = &H5280: LookupTable(199) = &H9241
  LookupTable(200) = &H9601: LookupTable(201) = &H56C0: LookupTable(202) = &H5780: LookupTable(203) = &H9741: LookupTable(204) = &H5500: LookupTable(205) = &H95C1: LookupTable(206) = &H9481: LookupTable(207) = &H5440
  LookupTable(208) = &H9C01: LookupTable(209) = &H5CC0: LookupTable(210) = &H5D80: LookupTable(211) = &H9D41: LookupTable(212) = &H5F00: LookupTable(213) = &H9FC1: LookupTable(214) = &H9E81: LookupTable(215) = &H5E40
  LookupTable(216) = &H5A00: LookupTable(217) = &H9AC1: LookupTable(218) = &H9B81: LookupTable(219) = &H5B40: LookupTable(220) = &H9901: LookupTable(221) = &H59C0: LookupTable(222) = &H5880: LookupTable(223) = &H9841
  LookupTable(224) = &H8801: LookupTable(225) = &H48C0: LookupTable(226) = &H4980: LookupTable(227) = &H8941: LookupTable(228) = &H4B00: LookupTable(229) = &H8BC1: LookupTable(230) = &H8A81: LookupTable(231) = &H4A40
  LookupTable(232) = &H4E00: LookupTable(233) = &H8EC1: LookupTable(234) = &H8F81: LookupTable(235) = &H4F40: LookupTable(236) = &H8D01: LookupTable(237) = &H4DC0: LookupTable(238) = &H4C80: LookupTable(239) = &H8C41
  LookupTable(240) = &H4400: LookupTable(241) = &H84C1: LookupTable(242) = &H8581: LookupTable(243) = &H4540: LookupTable(244) = &H8701: LookupTable(245) = &H47C0: LookupTable(246) = &H4680: LookupTable(247) = &H8641
  LookupTable(248) = &H8201: LookupTable(249) = &H42C0: LookupTable(250) = &H4380: LookupTable(251) = &H8341: LookupTable(252) = &H4100: LookupTable(253) = &H81C1: LookupTable(254) = &H8081: LookupTable(255) = &H4040
End Sub

Public Function CRC16GetDigest(ByRef Data() As Byte) As Integer 'LBound(Data) must be 0
  On Error Resume Next

  Dim tmpCRC As Integer, tmpC As Long

  tmpC = UBound(Data()) - LBound(Data()) + 1
  If tmpC > 0 Then
    Dim i As Long
    For i = LBound(Data()) To UBound(Data())
      tmpCRC = pShiftRightInt8(tmpCRC) Xor LookupTable(tmpCRC And &HFF Xor Data(i))
    Next i
  End If

  CRC16GetDigest = tmpCRC
End Function

Public Function CRC16GetHexFromString(ByRef Text As String, Optional ByVal UseUnicode As Boolean = True) As String
  Dim tmpB() As Byte, tmpDigest As String
  If UseUnicode = True Then
    tmpB() = Text
  Else
    tmpB() = StrConv(Text, vbFromUnicode)
  End If

  CRC16Init
  tmpDigest = Hex$(CRC16GetDigest(tmpB()))
  
  If Len(tmpDigest) < 4 Then
    CRC16GetHexFromString = String$(4 - Len(tmpDigest), "0") + tmpDigest
  Else
    CRC16GetHexFromString = tmpDigest
  End If
End Function



Private Function pShiftRightInt8(ByVal Data As Integer) As Integer
  Dim tmpData As Integer
  tmpData = (Data And &H7FFF) \ 256
  If (Data And &H8000) <> 0 Then
    tmpData = tmpData Or &H80
  End If
  pShiftRightInt8 = tmpData
End Function
