Attribute VB_Name = "mdlRC4"
'Author
'  Name .....: Josip Medved
'  E-mail ...: jmedved@vip.hr
'  URL ......: http://web.vip.hr/jmedved.vip/qeyes/

'Information
'  Additional : -
'  Requires ..: -
'  Has help ..: No
'  Has readme : No
'  Has sample : Yes
'  Created ...: - (yyyy/mm/dd)
'  Last update: 2002/04/12 (yyyy/mm/dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.


Private SBox(0 To 255) As Byte

Option Explicit

Public Sub RC4Init(ByRef Key() As Byte)
  On Error Resume Next
  
  Dim i As Long
  For i = LBound(SBox) To UBound(SBox)
    SBox(i) = i
  Next i
  
  Dim tmpLen  As Long
  tmpLen = UBound(Key()) - LBound(Key()) + 1
  
  If tmpLen > 0 Then
    Dim j As Long, tmpS As Byte
    For i = LBound(SBox) To UBound(SBox)
      j = (j + SBox(i) + Key(i Mod tmpLen)) Mod 256
      tmpS = SBox(j)
      SBox(j) = SBox(i)
      SBox(i) = tmpS
    Next i
  End If
End Sub


Public Sub RC4Process(ByRef Data() As Byte)
  On Error Resume Next

  Dim i As Long, j As Long, k As Long, tmpS As Byte
  For i = LBound(Data) To UBound(Data)
    k = (k + 1) Mod 256
    j = (j + SBox(k)) Mod 256
    tmpS = SBox(j)
    SBox(j) = SBox(k)
    SBox(k) = tmpS
    Data(i) = Data(i) Xor SBox((CLng(SBox(k)) + SBox(j)) Mod 256)
  Next i
End Sub



Public Sub RC4Crypt(ByRef Key() As Byte, ByRef Data() As Byte)
  RC4Init Key()
  RC4Process Data()
End Sub

Public Sub RC4Decrypt(ByRef Key() As Byte, ByRef Data() As Byte)
  RC4Init Key()
  RC4Process Data()
End Sub
