Attribute VB_Name = "mdlRegistry"
'Author
'  Name .....: Josip Medved
'  E-mail ...: jmedved@vip.hr
'  URL ......: http://web.vip.hr/jmedved.vip/qeyes/

'Information
'  Additional : -
'  Required ..: -
'  Has help ..: No
'  Has readme : No
'  Has sample : No
'  Created ...: - (yyyy/mm/dd)
'  Last update: 2002/04/12 (yyyy/mm/dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.


Option Explicit

Private Const KEY_CREATE_LINK = &H20
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_READ = &H20019
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_WRITE = &H20006
Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const SYNCHRONIZE = &H100000
Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))

Private Const REG_BINARY = 3
Private Const REG_DWORD = 4
Private Const REG_OPENED_EXISTING_KEY = &H2
Private Const REG_SZ = 1

Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, ByVal lpType As Long, ByVal lpData As Long, ByVal lpcbData As Long) As Long
Private Declare Function RegQueryValueExByte Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Byte, lpcbData As Long) As Long
Private Declare Function RegQueryValueExLong Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Long
Private Declare Function RegQueryValueExString Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegSetValueExByte Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Byte, ByVal cbData As Long) As Long
Private Declare Function RegSetValueExLong Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Long, ByVal cbData As Long) As Long
Private Declare Function RegSetValueExString Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long

Public Function RegistryGetByte(Key As String, ValueName As String, Default() As Byte, Create As Boolean, ByVal BufferSize As Long) As Byte()
  On Error Resume Next
  Dim tmpB() As Byte
  tmpB = Default

  If BufferSize = 0 Then BufferSize = 4096
  Dim tmpU As Long
  tmpU = UBound(tmpB()) - LBound(tmpB()) + 1
  If tmpU < BufferSize Then
    ReDim Preserve tmpB(0 To BufferSize)
    tmpU = BufferSize
  End If

  Dim tmpK As Long, tmpP As String
  tmpP = Key
  tmpK = KeyHandle(tmpP)
  
  Dim tmpRet As Long, tmpH As Long, tmpE As Boolean
  tmpRet = RegOpenKeyEx(tmpK, tmpP, 0, KEY_READ, tmpH)
  tmpRet = RegQueryValueExByte(tmpH, ValueName, 0, REG_BINARY, tmpB(0), tmpU)
  If tmpRet <> 0 Then tmpE = True
  tmpRet = RegCloseKey(tmpH)

  If tmpE = True Then tmpB = Default

  If tmpE = True And Create = True Then RegistryLetByte Key, ValueName, Default
  If tmpU = 0 Then
    Erase tmpB()
  Else
    ReDim Preserve tmpB(0 To tmpU - 1)
  End If
  RegistryGetByte = tmpB()
End Function

Public Sub RegistryLetByte(Key As String, ValueName As String, Value() As Byte)
  On Error Resume Next
  Dim tmpK As Long, tmpP As String
  tmpP = Key
  tmpK = KeyHandle(tmpP)

  Dim tmpU As Long
  tmpU = UBound(Value()) - LBound(Value()) + 1
  If tmpU = 0 Then ReDim Value(0 To 0)

  Dim tmpRet As Long, tmpH As Long
  tmpRet = RegOpenKeyEx(tmpK, tmpP, 0, KEY_WRITE, tmpH)
  If tmpRet = 2 Then tmpRet = RegCreateKey(tmpK, tmpP, tmpH)
  tmpRet = RegSetValueExByte(tmpH, ValueName, 0&, REG_BINARY, Value(0), tmpU)
  tmpRet = RegCloseKey(tmpH)
  
  If tmpU = 0 Then Erase Value()
End Sub

Public Function RegistryGetLong(Key As String, Optional ValueName As String = "", Optional Default As Long = 0, Optional Create As Boolean = False) As Long
  Dim tmpB As Long
  tmpB = 0

  Dim tmpK As Long, tmpP As String
  tmpP = Key
  tmpK = KeyHandle(tmpP)
  
  Dim tmpRet As Long, tmpH As Long, tmpE As Boolean
  tmpRet = RegOpenKeyEx(tmpK, tmpP, 0, KEY_READ, tmpH)
  tmpRet = RegQueryValueExLong(tmpH, ValueName, 0&, REG_DWORD, tmpB, 4)
  If tmpRet <> 0 Then tmpE = True
  tmpRet = RegCloseKey(tmpH)

  If tmpE = True Then tmpB = Default

  If tmpE = True And Create = True Then RegistryLetLong Key, ValueName, Default
  RegistryGetLong = tmpB
End Function

Public Sub RegistryLetLong(Key As String, Optional ValueName As String = "", Optional Value As Long = 0)
  Dim tmpK As Long, tmpP As String
  tmpP = Key
  tmpK = KeyHandle(tmpP)

  Dim tmpRet As Long, tmpH As Long
  tmpRet = RegOpenKeyEx(tmpK, tmpP, 0, KEY_WRITE, tmpH)
  If tmpRet = 2 Then tmpRet = RegCreateKey(tmpK, tmpP, tmpH)
  tmpRet = RegSetValueExLong(tmpH, ValueName, 0&, REG_DWORD, Value, 4)
  tmpRet = RegCloseKey(tmpH)
End Sub

Public Function RegistryGetString(Key As String, Optional ValueName As String = "", Optional Default As String = "", Optional Create As Boolean = False, Optional BufferSize As Long = 4096) As String
  Dim tmpB As String, tmpU As Long
  
  If BufferSize < 1 Then
    tmpB = String(4096, 0)
  Else
    tmpB = String(BufferSize, 0)
  End If
  tmpU = Len(tmpB)

  Dim tmpK As Long, tmpP As String
  tmpP = Key
  tmpK = KeyHandle(tmpP)
  
  Dim tmpRet As Long, tmpH As Long, tmpE As Boolean
  tmpRet = RegOpenKeyEx(tmpK, tmpP, 0, KEY_READ, tmpH)
  tmpRet = RegQueryValueExString(tmpH, ValueName, 0&, REG_SZ, tmpB, tmpU)
  If tmpRet <> 0 Then tmpE = True
  tmpRet = RegCloseKey(tmpH)

  If tmpE = True Then
    tmpB = Default
  Else
    tmpB = Left$(tmpB, tmpU - 1)
  End If

  If tmpE = True And Create = True Then RegistryLetString Key, ValueName, Default
  RegistryGetString = tmpB
End Function

Public Sub RegistryLetString(Key As String, Optional ValueName As String = "", Optional Value As String = "")
  Dim tmpK As Long, tmpP As String
  tmpP = Key
  tmpK = KeyHandle(tmpP)

  Dim tmpRet As Long, tmpH As Long
  tmpRet = RegOpenKeyEx(tmpK, tmpP, 0, KEY_WRITE, tmpH)
  If tmpRet = 2 Then tmpRet = RegCreateKey(tmpK, tmpP, tmpH)
  tmpRet = RegSetValueExString(tmpH, ValueName, 0&, REG_SZ, ByVal Value + vbNullChar, Len(Value) + 1)
  tmpRet = RegCloseKey(tmpH)
End Sub

Public Sub RegistryCreateKey(Key As String)
  Dim tmpK As Long, tmpP As String
  tmpP = Key
  tmpK = KeyHandle(tmpP)

  Dim tmpRet As Long, tmpH As Long
  tmpRet = RegOpenKeyEx(tmpK, tmpP, 0, KEY_ALL_ACCESS, tmpH)
  tmpRet = RegCreateKey(tmpK, tmpP, tmpH)
  tmpRet = RegCloseKey(tmpH)
End Sub

Public Sub RegistryDeleteKey(Key As String, Optional DeleteSubValues As Boolean = False)
  On Error Resume Next
  
  If DeleteSubValues = True Then
    Dim tmpKeys() As String, tmpValueNames() As String
    RegistryEnumKey Key, tmpKeys()
    RegistryEnumValue Key, tmpValueNames()
    Dim tmpU As Long, i As Long, tmpKey As String
    tmpU = UBound(tmpKeys()) - LBound(tmpKeys()) + 1
    If tmpU <> 0 Then
      For i = LBound(tmpKeys()) To UBound(tmpKeys())
        If Right(Key, 1) <> "\" Then tmpKey = Key + "\" Else tmpKey = Key
        RegistryDeleteKey tmpKey + tmpKeys(i), True
      Next i
    End If
    
    tmpU = 0
    tmpU = UBound(tmpValueNames()) - LBound(tmpValueNames()) + 1
    If tmpU <> 0 Then
      For i = LBound(tmpValueNames()) To UBound(tmpValueNames())
        RegistryDeleteValue Key, tmpValueNames(i)
      Next i
    End If
  End If


  Dim tmpK As Long, tmpP As String
  tmpP = Key
  tmpK = KeyHandle(tmpP)

  Dim tmpRet As Long, tmpH As Long
  tmpRet = RegDeleteKey(tmpK, tmpP)
End Sub

Public Sub RegistryDeleteValue(Key As String, Optional ValueName As String = "")
  Dim tmpK As Long, tmpP As String
  tmpP = Key
  tmpK = KeyHandle(tmpP)
  
  Dim tmpRet As Long, tmpH As Long
  tmpRet = RegOpenKeyEx(tmpK, tmpP, 0, KEY_WRITE, tmpH)
  tmpRet = RegDeleteValue(tmpH, ValueName)
  tmpRet = RegCloseKey(tmpH)
End Sub


Public Sub RegistryEnumKey(Key As String, Keys() As String, Optional BufferSize As Long = 4096)
  Dim tmpB As String
  
  If BufferSize < 1 Then
    tmpB = String(4096, 0)
  Else
    tmpB = String(BufferSize, 0)
  End If
  Erase Keys()
  
  Dim tmpK As Long, tmpP As String
  tmpP = Key
  tmpK = KeyHandle(tmpP)
  
  Dim tmpRet As Long, tmpH As Long, tmpE As Boolean
  tmpRet = RegOpenKeyEx(tmpK, tmpP, 0, KEY_ALL_ACCESS, tmpH)
  
  Dim tmpI As Long
  Do
    tmpRet = RegEnumKey(tmpH, tmpI, tmpB, Len(tmpB))
    If tmpRet = 259 Then
      Exit Do
    ElseIf tmpRet <> 0 Then
      Erase Keys()
      Exit Sub
    End If
    ReDim Preserve Keys(0 To tmpI)
    Keys(tmpI) = Left(tmpB, InStr(tmpB, vbNullChar) - 1)
    tmpI = tmpI + 1
  Loop
  
  tmpRet = RegCloseKey(tmpH)
End Sub

Public Sub RegistryEnumValue(Key As String, ValueNames() As String, Optional BufferSize As Long = 4096)
  Dim tmpB As String
  
  If BufferSize < 1 Then
    tmpB = String(4096, 0)
  Else
    tmpB = String(BufferSize, 0)
  End If
  Erase ValueNames()
  
  Dim tmpK As Long, tmpP As String
  tmpP = Key
  tmpK = KeyHandle(tmpP)
  
  Dim tmpRet As Long, tmpH As Long, tmpE As Boolean
  tmpRet = RegOpenKeyEx(tmpK, tmpP, 0, KEY_ALL_ACCESS, tmpH)
  
  Dim tmpI As Long
  Do
    tmpRet = RegEnumValue(tmpH, tmpI, tmpB, Len(tmpB), 0&, 0&, 0&, 0&)
    If tmpRet = 259 Then
      Exit Do
    ElseIf tmpRet <> 0 Then
      Erase ValueNames()
      Exit Sub
    End If
    ReDim Preserve ValueNames(0 To tmpI)
    ValueNames(tmpI) = Left(tmpB, InStr(tmpB, Chr(0)) - 1)
    tmpI = tmpI + 1
  Loop
  
  tmpRet = RegCloseKey(tmpH)
End Sub

Private Function KeyHandle(ByRef Path As String) As Long
  Dim tmpP As String, tmpH As String
  On Error Resume Next
  If Right$(Path, 1) = "\" Then tmpP = Path Else tmpP = Path + "\"
  tmpH = UCase$(Left$(tmpP, InStr(tmpP, "\") - 1))
  
  If Right$(tmpP, 1) = "\" Then tmpP = Left$(tmpP, Len(tmpP) - 1)
  
  Path = Mid$(tmpP, Len(tmpH) + 2, Len(tmpP) - Len(tmpH) - 1)

  Select Case tmpH
    Case "HKEY_CLASSES_ROOT", "HKCR"
      KeyHandle = &H80000000
    Case "HKEY_CURRENT_USER", "HKCU"
      KeyHandle = &H80000001
    Case "HKEY_LOCAL_MACHINE", "HKLM"
      KeyHandle = &H80000002
    Case "HKEY_USERS"
      KeyHandle = &H80000003
    Case "HKEY_PERFORMANCE_DATA"
      KeyHandle = &H80000004
    Case "HKEY_CURRENT_CONFIG", "HKCC"
      KeyHandle = &H80000005
    Case "HKEY_DYN_DATA"
      KeyHandle = &H80000006
    Case Else
  End Select
End Function
