Attribute VB_Name = "mdlSHA1"
'Author
'  Name .....: Josip Medved
'  E-mail ...: jmedved@vip.hr
'  URL ......: http://web.vip.hr/jmedved.vip/qeyes/

'Information
'  Requires ..: -
'  Additional : -
'  Has help ..: No
'  Has readme : No
'  Has sample : Yes
'  Created ...: - (yyyy/mm/dd)
'  Last update: 2002/07/04 (yyyy/mm/dd)

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.


Option Explicit


Private Declare Sub RtlMoveMemoryLongToByte Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Byte, ByRef Source As Long, ByVal Length As Long)


Private Type Word
  Bytes(0 To 3) As Byte
End Type


Private H(0 To 5) As Word
Private K(0 To 79) As Word

Public Sub SHA1Init()
  Dim i As Long

  For i = 0 To 19
    K(i).Bytes(0) = 90: K(i).Bytes(1) = 130: K(i).Bytes(2) = 121: K(i).Bytes(3) = 153
  Next i

  For i = 20 To 39
    K(i).Bytes(0) = 110: K(i).Bytes(1) = 217: K(i).Bytes(2) = 235: K(i).Bytes(3) = 161
  Next i

  For i = 40 To 59
    K(i).Bytes(0) = 143: K(i).Bytes(1) = 27: K(i).Bytes(2) = 188: K(i).Bytes(3) = 220
  Next i

  For i = 60 To 79
    K(i).Bytes(0) = 202: K(i).Bytes(1) = 98: K(i).Bytes(2) = 193: K(i).Bytes(3) = 214
  Next i


  H(0).Bytes(0) = 103: H(0).Bytes(1) = 69: H(0).Bytes(2) = 35: H(0).Bytes(3) = 1
  H(1).Bytes(0) = 239: H(1).Bytes(1) = 205: H(1).Bytes(2) = 171: H(1).Bytes(3) = 137
  H(2).Bytes(0) = 152: H(2).Bytes(1) = 186: H(2).Bytes(2) = 220: H(2).Bytes(3) = 254
  H(3).Bytes(0) = 16: H(3).Bytes(1) = 50: H(3).Bytes(2) = 84: H(3).Bytes(3) = 118
  H(4).Bytes(0) = 195: H(4).Bytes(1) = 210: H(4).Bytes(2) = 225: H(4).Bytes(3) = 240
End Sub

Public Function SHA1GetDigest(ByRef Data() As Byte) As Byte() 'LBound(Data) must be 0
  On Error Resume Next

  Dim tmpLength As Long
  tmpLength = UBound(Data()) + 1


  'Message padding
  Dim tmpBytesOver As Long, tmpBytesToPad As Long, tmpPaddedLength As Long
  tmpBytesOver = tmpLength Mod 64
  tmpBytesToPad = 64 - tmpBytesOver
  If tmpBytesToPad < 9 Then tmpBytesToPad = tmpBytesToPad + 64
  tmpPaddedLength = tmpLength + tmpBytesToPad
  ReDim Preserve Data(0 To tmpPaddedLength - 1)
  Data(tmpLength) = 128
  Dim tmpLengthData(0 To 3) As Byte
  RtlMoveMemoryLongToByte tmpLengthData(0), tmpLength * 8, 4
  Data(tmpPaddedLength - 4) = tmpLengthData(3): Data(tmpPaddedLength - 3) = tmpLengthData(2): Data(tmpPaddedLength - 2) = tmpLengthData(1): Data(tmpPaddedLength - 1) = tmpLengthData(0)



  Dim A As Word, b As Word, C As Word, D As Word, E As Word
  Dim TEMP As Word
  Dim W(0 To 79) As Word


  'Processing
  Dim i As Long, t As Long
  For i = 0 To tmpPaddedLength - 1 Step 64

    'a
    W(0).Bytes(0) = Data(i): W(0).Bytes(1) = Data(i + 1): W(0).Bytes(2) = Data(i + 2): W(0).Bytes(3) = Data(i + 3)
    W(1).Bytes(0) = Data(i + 4): W(1).Bytes(1) = Data(i + 5): W(1).Bytes(2) = Data(i + 6): W(1).Bytes(3) = Data(i + 7)
    W(2).Bytes(0) = Data(i + 8): W(2).Bytes(1) = Data(i + 9): W(2).Bytes(2) = Data(i + 10): W(2).Bytes(3) = Data(i + 11)
    W(3).Bytes(0) = Data(i + 12): W(3).Bytes(1) = Data(i + 13): W(3).Bytes(2) = Data(i + 14): W(3).Bytes(3) = Data(i + 15)
    W(4).Bytes(0) = Data(i + 16): W(4).Bytes(1) = Data(i + 17): W(4).Bytes(2) = Data(i + 18): W(4).Bytes(3) = Data(i + 19)
    W(5).Bytes(0) = Data(i + 20): W(5).Bytes(1) = Data(i + 21): W(5).Bytes(2) = Data(i + 22): W(5).Bytes(3) = Data(i + 23)
    W(6).Bytes(0) = Data(i + 24): W(6).Bytes(1) = Data(i + 25): W(6).Bytes(2) = Data(i + 26): W(6).Bytes(3) = Data(i + 27)
    W(7).Bytes(0) = Data(i + 28): W(7).Bytes(1) = Data(i + 29): W(7).Bytes(2) = Data(i + 30): W(7).Bytes(3) = Data(i + 31)
    W(8).Bytes(0) = Data(i + 32): W(8).Bytes(1) = Data(i + 33): W(8).Bytes(2) = Data(i + 34): W(8).Bytes(3) = Data(i + 35)
    W(9).Bytes(0) = Data(i + 36): W(9).Bytes(1) = Data(i + 37): W(9).Bytes(2) = Data(i + 38): W(9).Bytes(3) = Data(i + 39)
    W(10).Bytes(0) = Data(i + 40): W(10).Bytes(1) = Data(i + 41): W(10).Bytes(2) = Data(i + 42): W(10).Bytes(3) = Data(i + 43)
    W(11).Bytes(0) = Data(i + 44): W(11).Bytes(1) = Data(i + 45): W(11).Bytes(2) = Data(i + 46): W(11).Bytes(3) = Data(i + 47)
    W(12).Bytes(0) = Data(i + 48): W(12).Bytes(1) = Data(i + 49): W(12).Bytes(2) = Data(i + 50): W(12).Bytes(3) = Data(i + 51)
    W(13).Bytes(0) = Data(i + 52): W(13).Bytes(1) = Data(i + 53): W(13).Bytes(2) = Data(i + 54): W(13).Bytes(3) = Data(i + 55)
    W(14).Bytes(0) = Data(i + 56): W(14).Bytes(1) = Data(i + 57): W(14).Bytes(2) = Data(i + 58): W(14).Bytes(3) = Data(i + 59)
    W(15).Bytes(0) = Data(i + 60): W(15).Bytes(1) = Data(i + 61): W(15).Bytes(2) = Data(i + 62): W(15).Bytes(3) = Data(i + 63)

    'b
    For t = 16 To 79
      W(t) = OpS(OpXOR(OpXOR(OpXOR(W(t - 3), W(t - 8)), W(t - 14)), W(t - 16)), 1)
    Next t

    'c
    A = H(0): b = H(1): C = H(2): D = H(3): E = H(4)

    'd
    For t = 0 To 79
      TEMP = OpAdd(OpAdd(OpAdd(OpAdd(OpS(A, 5), OpF(b, C, D, t)), E), W(t)), K(t))
      E = D: D = C: C = OpS(b, 30): b = A: A = TEMP
    Next t
    
    'e
    H(0) = OpAdd(H(0), A): H(1) = OpAdd(H(1), b): H(2) = OpAdd(H(2), C): H(3) = OpAdd(H(3), D): H(4) = OpAdd(H(4), E)

  Next i



  Dim tmpResult() As Byte
  ReDim tmpResult(0 To 19)
  tmpResult(0) = H(0).Bytes(0): tmpResult(1) = H(0).Bytes(1): tmpResult(2) = H(0).Bytes(2): tmpResult(3) = H(0).Bytes(3)
  tmpResult(4) = H(1).Bytes(0): tmpResult(5) = H(1).Bytes(1): tmpResult(6) = H(1).Bytes(2): tmpResult(7) = H(1).Bytes(3)
  tmpResult(8) = H(2).Bytes(0): tmpResult(9) = H(2).Bytes(1): tmpResult(10) = H(2).Bytes(2): tmpResult(11) = H(2).Bytes(3)
  tmpResult(12) = H(3).Bytes(0): tmpResult(13) = H(3).Bytes(1): tmpResult(14) = H(3).Bytes(2): tmpResult(15) = H(3).Bytes(3)
  tmpResult(16) = H(4).Bytes(0): tmpResult(17) = H(4).Bytes(1): tmpResult(18) = H(4).Bytes(2): tmpResult(19) = H(4).Bytes(3)

  SHA1GetDigest = tmpResult
End Function

Public Function SHA1GetHexFromString(ByRef Text As String, Optional ByVal UseUnicode As Boolean = True) As String
  Dim tmpB() As Byte, tmpDigest() As Byte
  If UseUnicode = True Then
    tmpB() = Text
  Else
    tmpB() = StrConv(Text, vbFromUnicode)
  End If

  SHA1Init
  tmpDigest() = SHA1GetDigest(tmpB())

  Dim i As Long
  Dim tmpR As String
  For i = 0 To 19
    tmpR = tmpR + IIf(tmpDigest(i) < 16, "0", "") + Hex$(tmpDigest(i))
  Next i
  SHA1GetHexFromString = tmpR
End Function



Private Function OpAND(WordX As Word, WordY As Word) As Word
  Dim tmpResult As Word
  
  tmpResult.Bytes(0) = WordX.Bytes(0) And WordY.Bytes(0)
  tmpResult.Bytes(1) = WordX.Bytes(1) And WordY.Bytes(1)
  tmpResult.Bytes(2) = WordX.Bytes(2) And WordY.Bytes(2)
  tmpResult.Bytes(3) = WordX.Bytes(3) And WordY.Bytes(3)
  
  OpAND = tmpResult
End Function

Private Function OpOR(WordX As Word, WordY As Word) As Word
  Dim tmpResult As Word
  
  tmpResult.Bytes(0) = WordX.Bytes(0) Or WordY.Bytes(0)
  tmpResult.Bytes(1) = WordX.Bytes(1) Or WordY.Bytes(1)
  tmpResult.Bytes(2) = WordX.Bytes(2) Or WordY.Bytes(2)
  tmpResult.Bytes(3) = WordX.Bytes(3) Or WordY.Bytes(3)
  
  OpOR = tmpResult
End Function

Private Function OpXOR(WordX As Word, WordY As Word) As Word
  Dim tmpResult As Word
  
  tmpResult.Bytes(0) = WordX.Bytes(0) Xor WordY.Bytes(0)
  tmpResult.Bytes(1) = WordX.Bytes(1) Xor WordY.Bytes(1)
  tmpResult.Bytes(2) = WordX.Bytes(2) Xor WordY.Bytes(2)
  tmpResult.Bytes(3) = WordX.Bytes(3) Xor WordY.Bytes(3)
  
  OpXOR = tmpResult
End Function

Private Function OpNOT(WordX As Word) As Word
  Dim tmpResult As Word
  
  tmpResult.Bytes(0) = Not WordX.Bytes(0)
  tmpResult.Bytes(1) = Not WordX.Bytes(1)
  tmpResult.Bytes(2) = Not WordX.Bytes(2)
  tmpResult.Bytes(3) = Not WordX.Bytes(3)
  
  OpNOT = tmpResult
End Function

Private Function OpAdd(WordX As Word, WordY As Word) As Word
  Dim tmpResult As Word, tmpCarryByte As Long

'  tmpResult.Bytes(0) = CByte((CLng(WordX.Bytes(0)) + WordY.Bytes(0)) Mod 256)
'  tmpCarryByte = CByte((CLng(WordX.Bytes(0)) + WordY.Bytes(0)) \ 256)
'  tmpResult.Bytes(1) = CByte((tmpCarryByte + WordX.Bytes(1) + WordY.Bytes(1)) Mod 256)
'  tmpCarryByte = CByte((tmpCarryByte + WordX.Bytes(1) + WordY.Bytes(1)) \ 256)
'  tmpResult.Bytes(2) = CByte((tmpCarryByte + WordX.Bytes(2) + WordY.Bytes(2)) Mod 256)
'  tmpCarryByte = CByte((tmpCarryByte + WordX.Bytes(2) + WordY.Bytes(2)) \ 256)
'  tmpResult.Bytes(3) = CByte((tmpCarryByte + WordX.Bytes(3) + WordY.Bytes(3)) Mod 256)

  tmpResult.Bytes(3) = CByte((CLng(WordX.Bytes(3)) + WordY.Bytes(3)) Mod 256)
  tmpCarryByte = CByte((CLng(WordX.Bytes(3)) + WordY.Bytes(3)) \ 256)
  tmpResult.Bytes(2) = CByte((tmpCarryByte + WordX.Bytes(2) + WordY.Bytes(2)) Mod 256)
  tmpCarryByte = CByte((tmpCarryByte + WordX.Bytes(2) + WordY.Bytes(2)) \ 256)
  tmpResult.Bytes(1) = CByte((tmpCarryByte + WordX.Bytes(1) + WordY.Bytes(1)) Mod 256)
  tmpCarryByte = CByte((tmpCarryByte + WordX.Bytes(1) + WordY.Bytes(1)) \ 256)
  tmpResult.Bytes(0) = CByte((tmpCarryByte + WordX.Bytes(0) + WordY.Bytes(0)) Mod 256)

  OpAdd = tmpResult
End Function

Private Function OpS(WordX As Word, ByVal Amount As Long) As Word
  Dim tmpResult As Word, tmpCarryByte As Byte

  tmpResult = WordX
  Do Until Amount < 8
    tmpCarryByte = tmpResult.Bytes(0)
    tmpResult.Bytes(0) = tmpResult.Bytes(1)
    tmpResult.Bytes(1) = tmpResult.Bytes(2)
    tmpResult.Bytes(2) = tmpResult.Bytes(3)
    tmpResult.Bytes(3) = tmpCarryByte
    Amount = Amount - 8
  Loop

  Dim tmpMaskCarry As Byte, tmpMaskShift As Byte, tmpMaskMove As Byte
  If Amount = 0 Then
  ElseIf Amount = 1 Then
    tmpMaskCarry = 128: tmpMaskShift = 127: tmpMaskMove = 2
  ElseIf Amount = 2 Then
    tmpMaskCarry = 192: tmpMaskShift = 63: tmpMaskMove = 4
  ElseIf Amount = 3 Then
    tmpMaskCarry = 224: tmpMaskShift = 31: tmpMaskMove = 8
  ElseIf Amount = 4 Then
    tmpMaskCarry = 240: tmpMaskShift = 15: tmpMaskMove = 16
  ElseIf Amount = 5 Then
    tmpMaskCarry = 248: tmpMaskShift = 7: tmpMaskMove = 32
  ElseIf Amount = 6 Then
    tmpMaskCarry = 252: tmpMaskShift = 3: tmpMaskMove = 64
  ElseIf Amount = 7 Then
    tmpMaskCarry = 254: tmpMaskShift = 1: tmpMaskMove = 128
  End If

  If Amount > 0 Then
    tmpCarryByte = (tmpResult.Bytes(0) And tmpMaskCarry) \ (tmpMaskShift + 1)
    tmpResult.Bytes(0) = (tmpResult.Bytes(0) And tmpMaskShift) * tmpMaskMove + (tmpResult.Bytes(1) And tmpMaskCarry) \ (tmpMaskShift + 1)
    tmpResult.Bytes(1) = (tmpResult.Bytes(1) And tmpMaskShift) * tmpMaskMove + (tmpResult.Bytes(2) And tmpMaskCarry) \ (tmpMaskShift + 1)
    tmpResult.Bytes(2) = (tmpResult.Bytes(2) And tmpMaskShift) * tmpMaskMove + (tmpResult.Bytes(3) And tmpMaskCarry) \ (tmpMaskShift + 1)
    tmpResult.Bytes(3) = (tmpResult.Bytes(3) And tmpMaskShift) * tmpMaskMove + tmpCarryByte
  End If

  OpS = tmpResult
End Function

Private Function OpF(WordB As Word, WordC As Word, WordD As Word, t As Long) As Word
  Dim tmpResult As Word

  If (0 <= t) And (t <= 19) Then
    tmpResult = OpOR(OpAND(WordB, WordC), OpAND(OpNOT(WordB), WordD))
  ElseIf (20 <= t) And (t <= 39) Then
    tmpResult = OpXOR(OpXOR(WordB, WordC), WordD)
  ElseIf (40 <= t) And (t <= 59) Then
    tmpResult = OpOR(OpOR(OpAND(WordB, WordC), OpAND(WordB, WordD)), OpAND(WordC, WordD))
  ElseIf (60 <= t) And (t <= 79) Then
    tmpResult = OpXOR(OpXOR(WordB, WordC), WordD)
  End If

  OpF = tmpResult
End Function
