Attribute VB_Name = "mdlShuffle"
'Shuffles zero-based arrays.
'
'Author
'  Name .....: Josip Medved
'  E-mail ...: jmedved@vip.hr
'  URL ......: http://web.vip.hr/jmedved.vip/qeyes/

'Information
'  Requires ..: -
'  Additional : -
'  Has help ..: No
'  Has readme : No
'  Has sample : No
'  Created ...: 2002/09/08 (yyyy/mm/dd)
'  Last update: 2002/09/08 (yyyy/mm/dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.


Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Public Sub ShuffleLong(ByRef Data() As Long, Optional ByVal Range As Long = 0)
  'Data [in, out] - zero-based array to randomize
  'Range [in] - range for randomize function - valid entries are 0 to ubound(Data)

  Randomize GetTickCount

  On Error Resume Next
  Dim tmpCount As Long
  tmpCount = UBound(Data()) + 1
  If Range <= 0 Then Range = tmpCount - 1

  Dim i As Long, j As Long, s As Long
  For i = 0 To tmpCount - 2
    j = i + Fix(Rnd * (Range + 1))
    If j > tmpCount - 1 Then j = tmpCount - 1
    s = Data(i)
    Data(i) = Data(j)
    Data(j) = s
  Next i
End Sub

Public Sub ShuffleString(ByRef Data() As String, Optional ByVal Range As Long = 0)
  'Data [in, out] - zero-based array to randomize
  'Range [in] - range for randomize function - valid entries are 0 to ubound(Data)

  Randomize GetTickCount

  On Error Resume Next
  Dim tmpCount As Long
  tmpCount = UBound(Data()) + 1
  If Range <= 0 Then Range = tmpCount - 1

  Dim i As Long, j As Long, s As String
  For i = 0 To tmpCount - 2
    j = i + Fix(Rnd * (Range + 1))
    If j > tmpCount - 1 Then j = tmpCount - 1
    s = Data(i)
    Data(i) = Data(j)
    Data(j) = s
  Next i
End Sub
