Attribute VB_Name = "mdlShutDown"
'Author
'  Name .....: Josip Medved
'  E-mail ...: jmedved@vip.hr
'  URL ......: http://web.vip.hr/jmedved.vip/qeyes/

'Information
'  Requires ..: -
'  Additional : -
'  Has help ..: No
'  Has readme : No
'  Has sample : Yes
'  Created ...: - (yyyy/mm/dd)
'  Last update: 2002/06/22 (yyyy/mm/dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.


Option Explicit

Private Const ERROR_SUCCESS As Long = 0&
Private Const EWX_LOGOFF As Long = 0
Private Const EWX_SHUTDOWN As Long = 1
Private Const EWX_REBOOT As Long = 2
Private Const EWX_FORCE As Long = 4
Private Const EWX_POWEROFF As Long = 8
'EWX_FORCEIFHUNG
Private Const SE_SHUTDOWN_NAME As String = "SeShutdownPrivilege"
Private Const SE_PRIVILEGE_ENABLED As Long = &H2
Private Const SSPS_HIBERNATE As Long = &H0
Private Const SSPS_SUSPEND As Long = &H1
Private Const TOKEN_ADJUST_PRIVILEGES As Long = &H20
Private Const TOKEN_QUERY As Long = &H8

Private Declare Function AdjustTokenPrivileges Lib "advapi32.dll" (ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, PreviousState As TOKEN_PRIVILEGES, ReturnLength As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function ExitWindowsEx Lib "user32" (ByVal uFlags As Long, ByVal dwReserved As Long) As Long
Private Declare Function GetCurrentProcess Lib "kernel32" () As Long
Private Declare Function GetLastError Lib "kernel32" () As Long
Private Declare Function GetVersion Lib "kernel32" () As Long
Private Declare Function IsPwrHibernateAllowed Lib "Powrprof" () As Long
Private Declare Function IsPwrShutdownAllowed Lib "Powrprof" () As Long
Private Declare Function IsPwrSuspendAllowed Lib "Powrprof" () As Long
Private Declare Function LookupPrivilegeValue Lib "advapi32.dll" Alias "LookupPrivilegeValueA" (ByVal lpSystemName As String, ByVal lpName As String, lpLuid As LUID) As Long
Private Declare Function OpenProcessToken Lib "advapi32.dll" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
Private Declare Sub SetLastError Lib "kernel32" (ByVal dwErrCode As Long)
Private Declare Function SetSuspendState Lib "Powrprof" (ByVal Hibernate As Long, ByVal ForceCritical As Long, DisableWakeEvent As Long) As Long
Private Declare Function SetSystemPowerState Lib "kernel32" (ByVal fSuspend As Long, ByVal fForce As Long) As Long


Private Type LUID
  lowpart As Long
  highpart As Long
End Type

Private Type LUID_AND_ATTRIBUTES
  pLuid As LUID
  Attributes As Long
End Type

Private Type TOKEN_PRIVILEGES
  PrivilegeCount As Long
  Privileges(0) As LUID_AND_ATTRIBUTES
End Type

Public Sub ShutdownLogOff(Optional Force As Boolean = False)
  Dim tmpRet As Long
  Select Case Force
    Case False
      tmpRet = ExitWindowsEx(EWX_LOGOFF, 0)
    Case True
      tmpRet = ExitWindowsEx(EWX_LOGOFF Or EWX_FORCE, 0)
  End Select
End Sub

Public Sub ShutdownShutDown(Optional Force As Boolean = False)
  If IsWinNT = True Then AdjustToken

  Dim tmpRet As Long
  Select Case Force
    Case False
      tmpRet = ExitWindowsEx(EWX_SHUTDOWN, 0)
    Case True
      tmpRet = ExitWindowsEx(EWX_SHUTDOWN Or EWX_FORCE, 0)
  End Select
End Sub

Public Sub ShutdownReboot(Optional Force As Boolean = False)
  If IsWinNT = True Then AdjustToken

  Dim tmpRet As Long
  Select Case Force
    Case False
      tmpRet = ExitWindowsEx(EWX_REBOOT, 0)
    Case True
      tmpRet = ExitWindowsEx(EWX_REBOOT Or EWX_FORCE, 0)
  End Select
End Sub

Public Sub ShutdownPowerOff(Optional Force As Boolean = False)
  If IsWinNT = True Then AdjustToken

  Dim tmpRet As Long
  Select Case Force
    Case False
      tmpRet = ExitWindowsEx(EWX_POWEROFF, 0)
    Case True
      tmpRet = ExitWindowsEx(EWX_POWEROFF Or EWX_FORCE, 0)
  End Select
End Sub

Public Sub ShutdownHibernate(Optional Force As Boolean = False)
  On Error Resume Next
  If IsWinNT = True Then AdjustToken

  Dim tmpRet As Long
  Select Case Force
    Case False
      tmpRet = SetSystemPowerState(SSPS_HIBERNATE, 0)
    Case True
      tmpRet = SetSystemPowerState(SSPS_HIBERNATE, 1)
  End Select
End Sub

Public Sub ShutdownSuspend(Optional Force As Boolean = False)
  On Error Resume Next
  If IsWinNT = True Then AdjustToken

  Dim tmpRet As Long
  Select Case Force
    Case False
      tmpRet = SetSystemPowerState(SSPS_SUSPEND, 0)
    Case True
      tmpRet = SetSystemPowerState(SSPS_SUSPEND, 1)
  End Select
End Sub

Public Sub ShutdownHibernateEx(Optional Force As Boolean = False, Optional DisableWake As Boolean = False)
  On Error Resume Next
  If IsWinNT = True Then AdjustToken

  Dim tmpRet As Long
  Select Case Force
    Case False
      Select Case DisableWake
        Case False
          tmpRet = SetSuspendState(SSPS_HIBERNATE, 0, 0)
        Case True
          tmpRet = SetSuspendState(SSPS_HIBERNATE, 0, 1)
      End Select
    Case True
      Select Case DisableWake
        Case False
          tmpRet = SetSuspendState(SSPS_HIBERNATE, 1, 0)
        Case True
          tmpRet = SetSuspendState(SSPS_HIBERNATE, 1, 1)
      End Select
  End Select
End Sub

Public Sub ShutdownSuspendEx(Optional Force As Boolean = False, Optional DisableWake As Boolean = False)
  On Error Resume Next
  If IsWinNT = True Then AdjustToken

  Dim tmpRet As Long
  Select Case Force
    Case False
      Select Case DisableWake
        Case False
          tmpRet = SetSuspendState(SSPS_SUSPEND, 0, 0)
        Case True
          tmpRet = SetSuspendState(SSPS_SUSPEND, 0, 1)
      End Select
    Case True
      Select Case DisableWake
        Case False
          tmpRet = SetSuspendState(SSPS_SUSPEND, 1, 0)
        Case True
          tmpRet = SetSuspendState(SSPS_SUSPEND, 1, 1)
      End Select
  End Select
End Sub

Public Function ShutdownCanHibernate() As Boolean
  On Error Resume Next
  ShutdownCanHibernate = CBool(IsPwrHibernateAllowed())
End Function

Public Function ShutdownCanPowerOff() As Boolean
  On Error Resume Next
  ShutdownCanPowerOff = CBool(IsPwrShutdownAllowed())
End Function

Public Function ShutdownCanSuspend() As Boolean
  On Error Resume Next
  ShutdownCanSuspend = CBool(IsPwrSuspendAllowed())
End Function


Private Sub AdjustToken()
  Dim tmpRet As Long
  Dim hToken As Long
  Dim tmpLuid As LUID
  Dim tkp As TOKEN_PRIVILEGES
  Dim tkpNewButIgnored As TOKEN_PRIVILEGES
  Dim lBufferNeeded As Long

  SetLastError 0

  tmpRet = OpenProcessToken(GetCurrentProcess(), (TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY), hToken)

  tmpRet = LookupPrivilegeValue("", SE_SHUTDOWN_NAME, tmpLuid)

  tkp.PrivilegeCount = 1
  tkp.Privileges(0).pLuid = tmpLuid
  tkp.Privileges(0).Attributes = SE_PRIVILEGE_ENABLED

  tmpRet = AdjustTokenPrivileges(hToken, 0, tkp, Len(tkpNewButIgnored), tkpNewButIgnored, lBufferNeeded)

  tmpRet = CloseHandle(hToken)
End Sub

Private Function IsWinNT() As Boolean
  Dim tmpVersion As Long
  tmpVersion = GetVersion()
  If (tmpVersion And &H80000000) = 0 Then
    IsWinNT = True
  Else
  End If
End Function
