'Class for calculating CRC16.
'
'Author
'  Name .....: Josip Medved
'  E-mail ...: support@jmedved.com
'  URL ......: http://www.jmedved.com?findbyname=crc16

'Information
'  Additional : -
'  Requires ..: -
'  Has help ..: No
'  Has readme : No
'  Has sample : Yes
'  Last update: 2004-10-18 (yyyy-mm-dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.

Option Compare Binary
Option Explicit On 
Option Strict On

Public Class CRC16

	Public Overloads Shared Function GetDigest(ByRef data() As Byte) As Short
		Dim tmpDigest As Short = &H0S, tmpLookup As Short() = {&H0S, &HC0C1S, &HC181S, &H140S, &HC301S, &H3C0, &H280S, &HC241S, &HC601S, &H6C0S, &H780S, &HC741S, &H500S, &HC5C1S, &HC481S, &H440S, &HCC01S, &HCC0S, &HD80S, &HCD41S, &HF00S, &HCFC1S, &HCE81S, &HE40S, &HA00S, &HCAC1S, &HCB81S, &HB40S, &HC901S, &H9C0S, &H880S, &HC841S, &HD801S, &H18C0S, &H1980S, &HD941S, &H1B00S, &HDBC1S, &HDA81S, &H1A40S, &H1E00S, &HDEC1S, &HDF81S, &H1F40S, &HDD01S, &H1DC0S, &H1C80S, &HDC41S, &H1400S, &HD4C1S, &HD581S, &H1540S, &HD701S, &H17C0S, &H1680S, &HD641S, &HD201S, &H12C0S, &H1380S, &HD341S, &H1100S, &HD1C1S, &HD081S, &H1040S, &HF001S, &H30C0S, &H3180S, &HF141S, &H3300S, &HF3C1S, &HF281S, &H3240S, &H3600S, &HF6C1S, &HF781S, &H3740S, &HF501S, &H35C0S, &H3480S, &HF441S, &H3C00S, &HFCC1S, &HFD81S, &H3D40S, &HFF01S, &H3FC0S, &H3E80S, &HFE41S, &HFA01S, &H3AC0S, &H3B80S, &HFB41S, &H3900S, &HF9C1S, &HF881S, &H3840S, &H2800S, &HE8C1S, &HE981S, &H2940S, &HEB01S, &H2BC0S, &H2A80S, &HEA41S, &HEE01S, &H2EC0S, &H2F80S, &HEF41S, &H2D00S, &HEDC1S, &HEC81S, &H2C40S, &HE401S, &H24C0S, &H2580S, &HE541S, &H2700S, &HE7C1S, &HE681S, &H2640S, &H2200S, &HE2C1S, &HE381S, &H2340S, &HE101S, &H21C0S, &H2080S, &HE041S, &HA001S, &H60C0S, &H6180S, &HA141S, &H6300S, &HA3C1S, &HA281S, &H6240S, &H6600S, &HA6C1S, &HA781S, &H6740S, &HA501S, &H65C0S, &H6480S, &HA441S, &H6C00S, &HACC1S, &HAD81S, &H6D40S, &HAF01S, &H6FC0S, &H6E80S, &HAE41S, &HAA01S, &H6AC0S, &H6B80S, &HAB41S, &H6900S, &HA9C1S, &HA881S, &H6840S, &H7800S, &HB8C1S, &HB981S, &H7940S, &HBB01S, &H7BC0S, &H7A80S, &HBA41S, &HBE01S, &H7EC0S, &H7F80S, &HBF41S, &H7D00S, &HBDC1S, &HBC81S, &H7C40S, &HB401S, &H74C0S, &H7580S, &HB541S, &H7700S, &HB7C1S, &HB681S, &H7640S, &H7200S, &HB2C1S, &HB381S, &H7340S, &HB101S, &H71C0S, &H7080S, &HB041S, &H5000S, &H90C1S, &H9181S, &H5140S, &H9301S, &H53C0S, &H5280S, &H9241S, &H9601S, &H56C0S, &H5780S, &H9741S, &H5500S, &H95C1S, &H9481S, &H5440S, &H9C01S, &H5CC0S, &H5D80S, &H9D41S, &H5F00S, &H9FC1S, &H9E81S, &H5E40S, &H5A00S, &H9AC1S, &H9B81S, &H5B40S, &H9901S, &H59C0S, &H5880S, &H9841S, &H8801S, &H48C0S, &H4980S, &H8941S, &H4B00S, &H8BC1S, &H8A81S, &H4A40S, &H4E00S, &H8EC1S, &H8F81S, &H4F40S, &H8D01S, &H4DC0S, &H4C80S, &H8C41S, &H4400S, &H84C1S, &H8581S, &H4540S, &H8701S, &H47C0S, &H4680S, &H8641S, &H8201S, &H42C0S, &H4380S, &H8341S, &H4100S, &H81C1S, &H8081S, &H4040S}
		Try
			For i As Integer = 0 To data.Length - 1
				tmpDigest = ShiftRight(tmpDigest, 8) Xor tmpLookup(tmpDigest And &HFF Xor data(i))
			Next i
		Catch ex As Exception
		End Try
		Return tmpDigest
	End Function

	Public Overloads Shared Function GetDigest(ByRef data As String, Optional ByVal useUnicode As Boolean = True) As Short
		Dim tmpData As Byte()
		If useUnicode = False Then
			tmpData = System.Text.ASCIIEncoding.ASCII.GetBytes(data)
		Else
			tmpData = System.Text.UnicodeEncoding.Unicode.GetBytes(data)
		End If
		Return GetDigest(tmpData)
	End Function


	Private Shared lookupMask16Pwr() As Short = {&H1, &H2, &H4, &H8, &H10, &H20, &H40, &H80, &H100, &H200, &H400, &H800, &H1000, &H2000, &H4000, &H8000S}
	Private Shared Function ShiftRight(ByVal data As Short, ByVal amount As Integer) As Short
		If (amount <= 0) Then
			Return data
		ElseIf (amount > 15) Then
			Return 0
		Else
			If (data And lookupMask16Pwr(15)) = lookupMask16Pwr(15) Then
				Return (data And &H7FFFS) \ lookupMask16Pwr(amount) Or lookupMask16Pwr(15 - amount)
			Else
				Return data \ lookupMask16Pwr(amount)
			End If
		End If
	End Function

End Class
