'Class that encloses registry access.
'
'Author
'  Name .....: Josip Medved
'  E-mail ...: support@jmedved.com
'  URL ......: http://www.jmedved.com?findbyname=registry

'Information
'  Additional : -
'  Requires ..: -
'  Has help ..: No
'  Has readme : No
'  Has sample : Yes
'  Last update: 2004-10-17 (yyyy-mm-dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.

Public Class Registry

	Public Overloads Shared Function Read(ByVal keyName As String, ByVal valueName As String) As String
		Return Read(keyName, valueName, "")
	End Function

	Public Overloads Shared Function Read(ByVal keyName As String, ByVal valueName As String, ByVal defaultvalue As String) As String
		Try
			Dim regKey As Microsoft.Win32.RegistryKey
			SetHive(regKey, keyName)
			regKey = regKey.OpenSubKey(keyName, False)
			Return regKey.GetValue(valueName, defaultvalue).ToString
		Catch ex As System.Exception
			Return defaultvalue
		End Try
	End Function

	Public Overloads Shared Function Read(ByVal keyName As String, ByVal valueName As String, ByVal defaultvalue As Integer) As Integer
		Try
			Dim regKey As Microsoft.Win32.RegistryKey
			SetHive(regKey, keyName)
			regKey = regKey.OpenSubKey(keyName, False)
			Return CInt(regKey.GetValue(valueName, defaultvalue))
		Catch ex As System.Exception
			Return defaultvalue
		End Try
	End Function

	Public Overloads Shared Sub Write(ByVal keyName As String, ByVal valueName As String, ByVal value As String)
		Try
			Dim regKeyMain As Microsoft.Win32.RegistryKey, regKey As Microsoft.Win32.RegistryKey
			SetHive(regKeyMain, keyName)
			regKey = regKeyMain.OpenSubKey(keyName, True)
			If regKey Is Nothing Then regKey = regKeyMain.CreateSubKey(keyName)
			regKey.SetValue(valueName, value)
		Catch ex As System.Exception
		End Try
	End Sub

	Public Overloads Shared Sub Write(ByVal keyName As String, ByVal valueName As String, ByVal value As Integer)
		Try
			Dim regKey As Microsoft.Win32.RegistryKey
			SetHive(regKey, keyName)
			regKey = regKey.CreateSubKey(keyName)
			If regKey Is Nothing Then regKey = regKey.OpenSubKey(keyName, True)
			regKey.SetValue(valueName, value)
		Catch ex As System.Exception
		End Try
	End Sub

	Public Overloads Shared Sub Delete(ByVal keyName As String)
		Try
			Dim regKey As Microsoft.Win32.RegistryKey
			SetHive(regKey, keyName)
			regKey.DeleteSubKeyTree(keyName)
		Catch ex As System.Exception
		End Try
	End Sub

	Public Overloads Shared Sub Delete(ByVal keyName As String, ByVal valueName As String)
		Try
			Dim regKey As Microsoft.Win32.RegistryKey
			SetHive(regKey, keyName)
			regKey = regKey.OpenSubKey(keyName, True)
			regKey.DeleteValue(valueName)
		Catch ex As System.Exception
		End Try
	End Sub


#Region "Private"

	Private Shared Sub SetHive(ByRef registryHive As Microsoft.Win32.RegistryKey, ByRef keyName As String)
		Dim i As Integer = keyName.IndexOf("\")
		If i = -1 Then Return
		Select Case keyName.Substring(0, i).ToUpper
			Case "HKEY_CLASSES_ROOT", "HKCR"
				registryHive = Microsoft.Win32.Registry.ClassesRoot
			Case "HKEY_CURRENT_CONFIG"
				registryHive = Microsoft.Win32.Registry.CurrentConfig
			Case "HKEY_CURRENT_USER", "HKCU"
				registryHive = Microsoft.Win32.Registry.CurrentUser
			Case "HKEY_DYN_DATA"
				registryHive = Microsoft.Win32.Registry.DynData
			Case "HKEY_LOCAL_MACHINE", "HKLM"
				registryHive = Microsoft.Win32.Registry.LocalMachine
			Case "HKEY_PERFORMANCE_DATA"
				registryHive = Microsoft.Win32.Registry.PerformanceData
			Case "HKEY_USERS"
				registryHive = Microsoft.Win32.Registry.Users
			Case Else
				Return
		End Select
		keyName = keyName.Substring(i + 1)
	End Sub

#End Region

End Class
